//+------------------------------------------------------------------+
//|                                                       Slopes.mq4 |
//|                                                       Ron Bollig |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Ron Bollig"
#property link      ""

#property indicator_separate_window
#property indicator_minimum -180
#property indicator_maximum 180
#property indicator_buffers 1
#property indicator_color1 Red

//---- input parameters
extern int   History      =1000;  // Number of bars to use for calculations
extern bool  UseClose     =true;
extern int   LineLength   =50;
//---- buffers
double SlopeValue[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
  SetIndexStyle(0,DRAW_LINE);
  SetIndexBuffer(0,SlopeValue);
//----
  return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
  return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  int counted_bars=IndicatorCounted();
  int i=Bars-counted_bars-1;
  if (i>History-1) i=History-1;
  while(i>=0)
    {
    double price1=iCustom(0,0,"!LinRegrBuf",UseClose,LineLength,0,i);  //Price at point #1
    double price2=iCustom(0,0,"!LinRegrBuf",UseClose,LineLength,0,LineLength-1+i);  //Price at point #2
    SlopeValue[i]=MathArctan(((price1-price2)/Point)/LineLength)/ 3.1415965 * 180;
    Comment("The angle is "+DoubleToStr(SlopeValue[i], 2)+" degrees");
  //  Comment("price1 is ",price1,"  price2 is ",price2);
    i--;
    }
//----
   
//----
  return(0);
  }
//+------------------------------------------------------------------+